<?php
class DpyhFarmOperatorAction extends CommonAction {
	const tableName =  'dpyh_farm_operator';
	/*

	*/
	 function sys_list(){
		$list = new \Jms\Gui\ClGrid();
		
		$list->sql_filter = function($search,&$cond){
		  $cond['RoleId'] = \Zndp\User\RoleEnum::FARM_OPERATOR;
		
		};
		$list->row_filter = function(&$row){
		  $where = array('ID'=>$row['FarmId']);
		  $farm_info = M('dpyh_farm')->where($where)->field('FarmName,ProvinceId,CityId,DistrictId')->find();
		  $row['FarmId_text'] = $farm_info['FarmName'];
		  $row['ProvinceId_text'] = \Jms\DB\Area::getProvinceName($farm_info['ProvinceId']);
		  $row['CityId_text'] = \Jms\DB\Area::getPrefectureName($farm_info['CityId']);
		  $row['DistrictId_text'] = \Jms\DB\Area::getDistrictName($farm_info['DistrictId']);
		};
		$list->display($this);
	}
	/*

	*/
	 function sys_addedit(){
		$form = new \Jiaruan\LigerIframeForm();
		$form->before_add = function(&$data){
			$farmid = I('get.farmid');
		  	$where = array('ID'=>$farmid);
		   $farm_info = M('dpyh_farm')->where($where)->find();
		  	if(!$farm_info){
				json_fail('农场ID不存在！');
		  	}
		  
		  	$data['ProjectID'] = C('CC_PROJECT_ID');
		  	$data['FarmId'] = $farm_info['ID'];
		  	$data['RoleId'] = \Zndp\User\RoleEnum::FARM_OPERATOR;
		  	
		};
		$form->before_save = function(&$data){
		  $farmid = I('get.id');
		  $data['UserName'] = trim($data['UserName']);
		  $data['Password'] = trim($data['Password']);
		  $cond = array('ID'=>$farmid);
		  $userinfo = M('uc_user')->where($cond)->field('UserName,Password')->find();
		  if($data['UserName'] != $userinfo['UserName'] && is_username_exists( $userinfo['ID'],$data['UserName'] ) ){
		    json_fail('该用户名已存在,请换一个！');
		  }
		  if( $data['Password'] != $userinfo['Password'] ){
		   $data['Password'] = (new \Zndp\User\Util)->encPwd( $data['Password'] );
		  }else{
			unset($data['Password']);  
		  }
		 
		
		};
		$form->display($this);
	}
	/*

	*/
	 function sys_single_list(){
		$list = new \Jms\Gui\ClGrid();
		
		$list->sql_filter = function($search,&$cond){
		  $farmid = I('get.farmid');
		  if(!$farmid){
		  	json_fail("农场ID不存在！");
		  }
		  $cond['FarmId'] = $farmid;
		  $cond['RoleId'] = \Zndp\User\RoleEnum::FARM_OPERATOR;
		
		};
		//工具栏过滤器
		$list->toolbar_filter = function(&$button){
			
			$farmid = I('get.farmid');
			if($button['icon'] == 'add'){
		   	  $button['url'] .= '&farmid=' .$farmid; //修改按钮网址
		   }
		};
		$list->display($this);
	}
	/*

	*/
	public function sys_delete_operator(){
		$id = I('get.id');
		if(!$id){
			json_fail('农场ID不存在!');
		}
		$where =array('ID'=>$id);
		$result = M('dpyh_farm_operator')->where($where)->delete();
		if(!$result){
			json_fail('删除失败！');
		}
		json_success('删除成功！');
	}

}